import axios from 'axios'
import { INIT_SALE_URL, CREATE_CUSTOMER_URL, PROCESS_SALE_URL } from '@/constants/resourcePaths'
import { CREATE_CUSTOMER } from '@/constants/actionTypes'

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    notify({ commit }, payload) {
        openerp.web.notification.do_warn('Atención', payload)
        return false
    },
    /**
     * 
     * @param {*} param0 
     */
    initSale({ dispatch }) {
        return axios.get(INIT_SALE_URL).then(response => {
            dispatch('explodeData', response.data)
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    explodeData({ dispatch }, payload) {
        for (let value in payload) {
            dispatch(`init${value[0].toUpperCase()}${value.slice(1)}`, payload[value])
        }
    },
    [CREATE_CUSTOMER] ({ dispatch }, payload) {
        const data = {
            jsonrpc: '2.0',
            method: 'call',
            params: {
                ...payload
            }
        }

        return axios.post(CREATE_CUSTOMER_URL, data).then(response => {
            console.log(response)
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * 
     * @param {*} param0 
     */
    createSale({ getters , dispatch }) {

    }
}

export default actions