import { SET_PAYMENT_TERMS, SET_LOADING_PAYMENT_TERMS } from '@/constants/mutationTypes'
import { INIT_PAYMENT_TERMS } from '@/constants/actionTypes'

const initialState = {
    paymentTerms: [],
    loadingPaymentTerms: false
}

const state = {
    paymentTerms: initialState.paymentTerms,
    loadingPaymentTerms: !initialState.loadingPaymentTerms
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    paymentTerms(state) {
        return state.paymentTerms
    },
    /**
     * 
     * @param {*} state 
     */
    loadingPaymentTerms(state) {
        return state.loadingPaymentTerms
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    [SET_PAYMENT_TERMS] (state, payload) {
        state.paymentTerms = payload
    },
    /**
     * 
     * @param {*} state 
     */
    [SET_LOADING_PAYMENT_TERMS] (state, payload) {
        state.loadingPaymentTerms = !!payload
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    [INIT_PAYMENT_TERMS] ({ commit }, payload) {
        commit(SET_PAYMENT_TERMS, payload)
        commit(SET_LOADING_PAYMENT_TERMS)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}